/**
 * SXPRTS2.java
 *
 * File generated from the medication2::SXPRTS2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.ArrayList;
import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class SXPRTS2.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SXPR_TS", propOrder = {
	"comp"
})
@XmlRootElement(name = "SXPR_TS")
public class SXPRTS2 extends net.ihe.gazelle.medication2.SXCMTS2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "comp", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.SXCMTS2> comp;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return comp.
	 * @return comp
	 */
	public List<net.ihe.gazelle.medication2.SXCMTS2> getComp() {
		if (comp == null) {
	        comp = new ArrayList<net.ihe.gazelle.medication2.SXCMTS2>();
	    }
	    return comp;
	}
	
	/**
	 * Set a value to attribute comp.
	 * @param comp.
	 */
	public void setComp(List<net.ihe.gazelle.medication2.SXCMTS2> comp) {
	    this.comp = comp;
	}
	
	
	
	/**
	 * Add a comp to the comp collection.
	 * @param comp_elt Element to add.
	 */
	public void addComp(net.ihe.gazelle.medication2.SXCMTS2 comp_elt) {
	    this.getComp().add(comp_elt);
	}
	
	/**
	 * Remove a comp to the comp collection.
	 * @param comp_elt Element to remove
	 */
	public void removeComp(net.ihe.gazelle.medication2.SXCMTS2 comp_elt) {
	    this.getComp().remove(comp_elt);
	}
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "SXPR_TS").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SXPRTS2 sXPRTS2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (sXPRTS2 != null){
   			net.ihe.gazelle.medication2.SXCMTS2.validateByModule(sXPRTS2, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.SXCMTS2 comp: sXPRTS2.getComp()){
					net.ihe.gazelle.medication2.SXCMTS2.validateByModule(comp, _location + "/comp[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}
